version: "3.0"

x-logging: &default-logging
    driver: "json-file"
    options:
        max-size: "500k"
        max-file: "10"

services:
  synapse:
    image: ghcr.io/element-hq/synapse:{{ synapse_version }}
    restart: unless-stopped
    environment:
      - SYNAPSE_CONFIG_PATH=/data/homeserver.yaml
    volumes:
      - {{ synapse_data }}/homeserver.yaml:/data/homeserver.yaml
      - {{ synapse_data }}:/data
    networks:
      - web
      - dinternal-db
    depends_on:
      - db
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=web"
      - "traefik.http.routers.{{ synapse_name }}.entrypoints=websecure"
      - "traefik.http.routers.{{ synapse_name }}.rule=Host(`{{ synapse_domain }}`)"
      - "traefik.http.routers.{{ synapse_name }}.tls.certresolver=httpsresolver"
      - "traefik.http.services.{{ synapse_name }}.loadbalancer.server.port=8080"
    logging:
      <<: *logging

  db:
      image: postgres:{{ synapse_postgre_version }}-alpine
      restart: unless-stopped
      expose :
        - 9000
        - 5432
      environment:
        - POSTGRES_PASSWORD={{ synapse_postgre_admin_password }}
        - TZ={{ timezone }}
        - PGTZ={{ timezone }}
        - POSTGRES_INITDB_ARGS=--encoding=UTF-8 --lc-collate=C --lc-ctype=C
    networks:
      - internal-db
    volumes:
      volumes:
        - db:/var/lib/postgresql/data
        - ./db/init:/docker-entrypoint-initdb.d/
        - {{ pg_nc_backupfile }}:/tmp/backup/backup.sql
      networks:
        - internal-db
      logging:
        <<: *logging

networks:
  internal-db:
  web:
    external: true

volumes:
  db:
